#include "memcpy_arm.h"

/*
  http://osdir.com/ml/lib.uclibc.general/2003-09/msg00107.html
 */


int
memcpy_arm_init (void)
{
#ifdef __arm__
  return 1;
#else
  return 0;
#endif /* !__arm__ */
}

void *
memcpy_arm(void * __restrict dst, const void * __restrict src, size_t size)
{
  register char *r1 = dst;
  register const char *r2 = src;

  if( ((int) r1 & 0x3) || ((int) r2 & 0x3) || ( size <= 0x38 ) )
    {
      while (size) {
	*r1++ = *r2++;
	--size;
      }
    }
  else
    __asm__ __volatile__ (
"1:"
                "ldmia   %0!,{r3-r9}"
                "stmia   %1!,{r3-r9}"
                "ldmia   %0!,{r3-r9}"
                "stmia   %1!,{r3-r9}"
                "subs    %2, %2, #0x38"
                "cmp     %2, #0x38"
                "bge     1b"
"2:"
                "cmp     %2, #4"
                "blt     3f"
                "ldr     r4,[%0]"
                "str     r4,[%1]"
                "add     %0, %0, #4"
                "add     %1, %1, #4"
                "sub     %2, %2, #4"
                "b       2b"
"3:"
                "cmp     %2, #0"
                "beq     4f"
                "ldrb    r4,[%0]"
                "strb    r4,[%1]"
                "add     %0, %0, #1"
                "add     %1, %1, #1"
                "sub     %2, %2, #1"
                "b       3b"
"4:"
			  :
			  : "r"(r2),"r"(r1),"r"(size)
			  : "r3","r4","r5","r6","r7","r8","r9" );
  return dst;
}
